HDU-1533 Going Home(二分图匹配)

最近开始做最小费用流的题目,该题是二分图完美匹配下的最小权匹配,所谓完美匹配就是说从源点流入的总流量等于从汇点流出的总流量,在这种状态下的最小费用 。

那么显然是要套用最小费用流模板,另外二分图匹配的第一步就是要划分集合,划分两个集合,集合A与源点相连,集合B与汇点相连,至于容量和权值就要依据题目而定 。

比如该题,因为每个小人恰好能对应一个房子,所以每个小人与汇点的容量为1,房子与汇点的容量为1,这样就保证了是完美匹配。 那么下一步要建立两个集合中元素之间的关系,那么容量显然是可以随便赋值的,因为每个房子到汇点的容量是1,已经限制了 。  另外每个人到每个房子的最短步数显然就是权值 。那么就很容易建图了 。

最小费用流算法用了最短路的Bellman算法,不过这个Edmonds-Karp算法貌似不是很快,时间复杂度O(v^2*E) 。

细节参见代码:

#include<bits/stdc++.h>
using namespace std;
typedef long long ll;
const int maxn = 200 + 5;
const int INF = 1000000000;
int T,n,t,m,a[maxn],p[maxn],d[maxn],inq[maxn],mm,hh;
struct Edge {
    int from, to, cap, flow, cost;
    Edge(int u,int v,int c,int f,int w):from(u),to(v),cap(c),flow(f),cost(w) {}
};
vector<Edge> edges;
vector<int> g[maxn];
void init() {
    for(int i=0;i<maxn;i++) g[i].clear();
    edges.clear();
}
void AddEdge(int from, int to, int cap, int cost) {
    edges.push_back(Edge(from,to,cap,0,cost));
    edges.push_back(Edge(to,from,0,0,-cost));
    t = edges.size();
    g[from].push_back(t-2);
    g[to].push_back(t-1);
}
bool BellmanFord(int s,int t,int& flow, ll& cost) {
    for(int i=0;i<maxn;i++) d[i] = INF;
    memset(inq,0,sizeof(inq));
    d[s] = 0; inq[s] = 1; p[s] = 0; a[s] = INF;
    queue<int> Q;
    Q.push(s);
    while(!Q.empty()) {
        int u = Q.front(); Q.pop();
        inq[u] = 0;
        for(int i = 0; i < g[u].size(); i++) {
            Edge& e = edges[g[u][i]];
            if(e.cap > e.flow && d[e.to] > d[u] + e.cost) {
                d[e.to] = d[u] + e.cost ;
                p[e.to] = g[u][i];
                a[e.to] = min(a[u],e.cap - e.flow);
                if(!inq[e.to]) { Q.push(e.to); inq[e.to] = 1; }
            }
        }
    }
    if(d[t] == INF) return false;
    flow += a[t];
    cost += (ll)d[t] *(ll)a[t];
    for(int u = t; u != s; u = edges[p[u]].from) {
        edges[p[u]].flow += a[t];
        edges[p[u]^1].flow -= a[t];
    }
    return true;
}
int MincostMaxflow(int s,int t, ll& cost) {
    int flow = 0; cost = 0;
    while(BellmanFord(s,t,flow,cost)) ;
    return flow;
}
struct node {
    int r,c;
    node(int r=0,int c=0): r(r),c(c) {}
    bool operator < (const node& v) const {
        return r < v.r || (r == v.r && c < v.c);
    }
}M[maxn],H[maxn];
char s[105][105];
int main() {
    while(~scanf("%d%d",&n,&m)) {
        if( !n && !m ) return 0;
        init() ;
        for(int i=1;i<=n;i++)
            scanf("%s",s[i]+1);
        mm = hh = 1;
        for(int i=1;i<=n;i++)
            for(int j=1;j<=m;j++) {
                if(s[i][j] == 'm') {
                    M[mm].r = i; M[mm++].c = j;
                }
                else if(s[i][j] == 'H') {
                    H[hh].r = i; H[hh++].c = j;
                }
            }
        int tt = hh+mm+2;
        for(int i=1;i<mm;i++) AddEdge(0,i,1,0);
        for(int i=1;i<hh;i++) AddEdge(i+mm,tt,1,0);
        for(int i=1;i<mm;i++) {
            for(int j=1;j<hh;j++) {
                int v = abs(M[i].r-H[j].r) + abs(M[i].c-H[j].c);
                AddEdge(i,j+mm,INF,v);
            }
        }
        ll ans = 0;
        int cnt = MincostMaxflow(0,tt,ans);
        printf("%I64d\n",ans);
    }
    return 0;
}

版权声明:本文为博主原创文章,未经博主允许不得转载。

时间: 2024-11-13 03:30:57

HDU-1533 Going Home(二分图匹配)的相关文章

HDU 1083 网络流之二分图匹配

http://acm.hdu.edu.cn/showproblem.php?pid=1083 二分图匹配用得很多 这道题只需要简化的二分匹配 #include<iostream> #include<cstdio> #include<cstring> #define maxm 410 using namespace std; int p,n; int master[maxm]; int linking[maxm][maxm]; int has[maxm]; int sol

hdu 5943(素数间隔+二分图匹配)

Kingdom of Obsession Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)Total Submission(s): 200    Accepted Submission(s): 64 Problem Description There is a kindom of obsession, so people in this kingdom do things ver

hdu 5093 Battle ships 二分图匹配

题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=5093 一开始就往贪心的方向想了结果wa全场 这种矩阵形式的图一般要联想到行和列构成了二分图 然后实质就是求一个最大匹配 中间的冰山实际上就是把一行或一列切成多个顶点而已 所以一开始预处理一下 然后就可以套用模板 #include <cstring> #include <cstdlib> #include <cstring> #include <cmath> #i

hdu - 1150 Machine Schedule (二分图匹配最小点覆盖)

http://acm.hdu.edu.cn/showproblem.php?pid=1150 有两种机器,A机器有n种模式,B机器有m种模式,现在有k个任务需要执行,没切换一个任务机器就需要重启一次, 如果任务i在机器A上执行,A机器需要一个对应的模式A,如果在机器B上执行,机器A需要一个模式B. 一直就是机器A在切换模式,现在让你安排一种合理的任务执行顺序,让机器重启次数最少. 每个任务之间连一条边.二分图的最小顶点覆盖就是求最少的点可以连接所有的边,然后转化成最大匹配即可. 这题就是初始状态

hdu 2819 Swap(二分图匹配)

hdu 2819 Swap Description Given an N*N matrix with each entry equal to 0 or 1. You can swap any two rows or any two columns. Can you find a way to make all the diagonal entries equal to 1? Input There are several test cases in the input. The first li

HDU 2819 隐式二分图匹配

http://acm.hdu.edu.cn/showproblem.php?pid=2819 这道题乍一看是矩阵变换题,估计用矩阵之类的也可以做 但是分析一下就可以知道 要凑成对角线都是1,题目允许行变换和列变换 然而观察可以得知如果可以完成只需要行变换或者列变换之一即可 donser[i][j]=1表示i,j位置有1,那么只需要变换j到i(即交换i,j行) 输出中间过程用queue 加上dfs遍历即可 #include<iostream> #include<cstdio> #in

hdu 1150 Machine Schedule (二分图匹配)

#include<cstdio> #include<cstring> #include<iostream> #include<algorithm> using namespace std; int n,m,k; int mat[110][110]; int link[110]; int vis[110]; bool find(int u) { int v; for(v=0;v<m;j++) if(g[u][v]&&!vis[v]) {

【图论】二分图匹配总结

二分图匹配总结 二分图匹配 1.二分图最大匹配.求两个集合内,每一个元素仅仅能用一次.两集合间存在一些匹配关系,求最大匹配多少对,利用匈牙利算法,对于每一个结点不断去找增广路去匹配 有几个重要性质: 1.最小点覆盖 = 最大匹配 2.最大独立集 = 总结点 - 最大匹配 模板: bool dfs(int u) { for (int i = 0; i < g[u].size(); i++) { int v = g[u][i]; if (vis[v]) continue; vis[v] = 1; i

HDU 1533 二分图最小权匹配 Going Home

带权二分图匹配,把距离当做权值,因为是最小匹配,所以把距离的相反数当做权值求最大匹配. 最后再把答案取一下反即可. 1 #include <iostream> 2 #include <cstdio> 3 #include <cstring> 4 #include <algorithm> 5 #include <map> 6 #include <vector> 7 #include <cmath> 8 #define MP

HDU 3081:Marriage Match II(二分图匹配+并查集)

http://acm.hdu.edu.cn/showproblem.php?pid=3081 题意:有n个男生n个女生,他们只有没有争吵或者女生a与男生A没有争吵,且女生b与女生a是朋友,因此女生b也可以和男生A过家家(具有传递性).给出m个关系,代表女生a和男生b没有争吵过.给出k个关系,代表女生a与女生b是好朋友.每一轮过家家之后,女生只能选择可以选择并且没选过的男生过家家,问游戏能进行几轮. 思路:因为n<=100,因此支持O(n^3)的算法,挺容易想到是一个二分图匹配的.(出现在我的网络